#include <stdio.h>
#include <time.h>
#include <unistd.h>

#define PORT "/dev/ttyS0"

FILE *f;
char buf[100];

void send(char *s) {
	char c = strlen(s);
	fprintf(f, "%c%s", c, s);
}

void draw() {
	send("d");
}

void string(int x, int y, char *s) {
	sprintf(buf, "s%d %d %s", x, y, s);
	send(buf);
}

void line(int fx, int fy, int tx, int ty) {
	sprintf(buf, "l%d %d %d %d", fx, fy, tx, ty);
	send(buf);
}

void rect(int x, int y, int w, int h, int corner) {
	sprintf(buf, "r%d %d %d %d %d", x, y, w, h, corner);
	send(buf);
}

void fill(int x, int y, int w, int h, int corner) {
	sprintf(buf, "f%d %d %d %d %d", x, y, w, h, corner);
	send(buf);
}

void seg(int fx, int fy, int w, int h, int s) {
	rect(fx - s, fy - s, w + s, h + s, 3);
}

void sevenseg(int x, int y, int w, int n) {
	int s = w/4;
	if (n != 1 && n != 4)
		seg(x, y, w, 0, s);
	if (n == 0 || (n > 3 && n != 7))
		seg(x, y, 0, w, s);
	if (n == 0 || n == 2 || n == 6 || n == 8)
		seg(x, y + w, 0, w, s);
	if (n == 0 || n == 2 || n == 3 || n == 5 || n == 6 || n == 8)
		seg(x, y + 2*w, w, 0, s);
	if (n != 2)
		seg(x + w, y + w, 0, w, s);
	if (n != 5 && n != 6)
		seg(x + w, y, 0, w, s);
	if (n != 0 && n != 1 && n != 7)
		seg(x, y + w, w, 0, s);
}

void drawtime(int x, int y, int w, struct tm *tm) {
	int s = w / 2, sp = w + s;
	sevenseg(x, y, w, tm->tm_hour / 10);
	sevenseg(x + sp, y, w, tm->tm_hour % 10);
	seg(x + 2*sp, y + w / 2, 0, 0, w/4);
	seg(x + 2*sp, y + w + w / 2, 0, 0, w/4);
	sevenseg(x + 2*sp + s, y, w, tm->tm_min / 10);
	sevenseg(x + 3*sp + s, y, w, tm->tm_min % 10);
}

int main(int argc, char **argv) {
	int i;

	f = fopen(PORT, "w");
	if (!f) {
		fprintf(stderr, "Unable to open port\n");
		exit(20);
	}

	while (1) {
		time_t t = time(NULL);
		struct tm *tm = localtime(&t);		

		string(0, 100, "hello world");
		drawtime(10, 10, 25, tm);
		draw();
		fflush(f);
		sleep(1);
	}

	fclose(f);
}

